<%inherit file="master.html" />
<div id="container">
    <div id="map-view">
    </div>
    <div id="player">
        <div class="form-check">
            <input id="tech" type="checkbox" class="form-check-input" checked>
            <label for="tech" class="form-check-label">Технические данные</label>
        </div>
        <div class="input-group input-group-sm">

            <div class="input-group-prepend">
                <span class="input-group-text">Аллерген</span>
            </div>
            <select name="allergen" class="form-control update-map">
            </select>
        </div>
        <div class="form-group">
            <button id="play-button" class="btn btn-outline-secondary btn-sm">play</button>
            <label for="hour-delta">dT <span id="hour-delta-info"></span> час.</label>
            <input id="hour-delta" class="form-control-range" type="range" min="-72" max="96" step="1" value="0">
        </div>
        <div id="bounding-info"></div>
    </div>
</div>
<div id="map-actions" class="pb-5">
    <div class="row">
        <div class="col-3">
            <a href="${url_for('index')}" class="btn btn-secondary mt-3 form-control" role="button">Назад</a>
        </div>
    </div>
</div>

<script>
    $(document).ready(() => {
        let mapDivId = 'map-view';              // id блочного элемента, в который подгружается карта (не селектор!)
        let playDelay = 600;                    // Задержка между "кадрами" при проигрывании

        let allergenSelect = $('select[name="allergen"]');
        let hourDelta = $('#hour-delta');
        let hourDeltaInfo = $('#hour-delta-info');
        let playButton = $('#play-button');

        let pollenMap = L.map(mapDivId, {zoomControl: false}).fitBounds([[50, 28], [60, 38]]);  // Подключение карты Leaflet

        L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {   // Подложка
            maxZoom: 19,
            attribution: '&copy; <a href="https://openstreetmap.org/copyright">OpenStreetMap contributors</a>'
        }).addTo(pollenMap);

        let layers = {};        // [Количество слоёв] = [количество аллергенов] × [количество временных отметок]
                                // В качестве ключей выбрана конкатенация [Имя аллергена] + [временная отметка]
        let activeLayer = null; // Текущий активный слой
        let geoJsonPath;        // Часть пути с расположением данных geoJson
        let intervalPath;       // Часть пути с расположением временных отметок
        let playerOn = false;   // Отслеживание плеера

        let switchFrame = (key) => {
            if (activeLayer !== null) {  // При первом вызове функции активный слой не определён
                activeLayer.removeFrom(pollenMap);
            }
            activeLayer = layers[key].addTo(pollenMap);
        };

        let updateMap = () => {
            /* Функция обновления содержимого карты. Запускается при выборе аллергена и смене временной отмети */

            let allergenName = allergenSelect.children('option:selected').html();
            let hourDeltaValue = hourDelta.val();
            let key = allergenName + hourDeltaValue;  // конкатенация [Имя аллергена] + [временная отметка]
            if (layers[key] === null) {               // Создание слоя при первом обращении к нему и подгрузка данных
                layers[key] = L.layerGroup();
                let allergenPath = allergenSelect.val();
                let forecastPath = intervalPath[hourDeltaValue];
                $.ajax({
                    url: geoJsonPath + allergenPath + forecastPath,
                    dataType: 'json',
                    beforeSend: () => {   // Отключаем ползунок и выбор аллергена на время запроса
                        if (!playerOn) {  // При включенном плеере не реагировать
                            allergenSelect.prop('disabled', true);
                            hourDelta.prop('disabled', true);
                        }
                    }, // --beforeSend
                    complete: () => {     // Включаем ползунок и выбор аллергена по окончании запроса
                        if (!playerOn) {  // При включенном плеере не реагировать
                            allergenSelect.prop('disabled', false);
                            hourDelta.prop('disabled', false);
                        }
                    }, // --complete
                    success: (jsonData) => {
                        $.each(jsonData, (MPIndex, MultiPolygon) => {
                            L.polygon(MultiPolygon['latlngs'], {
                                color: MultiPolygon['color'],
                                fillColor: MultiPolygon['fillColor'],
                                fillOpacity: 0.2,
                                opacity: MultiPolygon['opacity'],
                                weight: MultiPolygon['weight']
                            }).addTo(layers[key]);
                        });
                        switchFrame(key);
                    }  // --success
                });  // --$.ajax
            } else {
                switchFrame(key);
            }
        };

        let play = (msDelay = 1000) => {
            /* Функция проигрывания временных отступов */

            if (playerOn) {
                let hourDeltaMin = parseInt(hourDelta.attr('min'));
                let hourDeltaMax = parseInt(hourDelta.attr('max'));
                let hourDeltaStep = parseInt(hourDelta.attr('step'));
                let hourDeltaVal = parseInt(hourDelta.val());
                let nextVal;
                if (hourDeltaVal === hourDeltaMax) {
                    nextVal = hourDeltaMin;
                } else {
                    nextVal = hourDeltaVal + hourDeltaStep;
                }
                hourDelta.val(nextVal);
                hourDelta.trigger('input');   // Меняет подпись временной отметки
                hourDelta.trigger('change');  // Обновляет содержимое карты
                setTimeout(play, msDelay);
            }
        };

        playButton.on('click', () => {
            if (playerOn) {
                allergenSelect.prop('disabled', false);
                hourDelta.prop('disabled', false);
                playButton.html('play');
                playerOn = false;
            } else {
                allergenSelect.prop('disabled', true);
                hourDelta.prop('disabled', true);
                playButton.html('stop');
                playerOn = true;
                play(playDelay);
            }
        });

        allergenSelect.on('change', updateMap);
        hourDelta.on('change', updateMap);
        hourDelta.on('input', () => {
            hourDeltaInfo.html(hourDelta.val());
        });

        // Техническая часть
        let updateBoundsAndZoom = () => {
            let bounds = pollenMap.getBounds();
            let zoom = pollenMap.getZoom();
            $('#bounding-info').html('bounds: ' + bounds.getNorthWest() + ', ' + bounds.getSouthEast() + '<br> zoom: ' + zoom);
        };

        let techLayer = L.layerGroup().addTo(pollenMap);
        let tech = $('#tech');
        tech.on('change', () => {
            if (tech.prop('checked')) {
                techLayer.addTo(pollenMap);
            } else {
                techLayer.removeFrom(pollenMap);
            }
        });

        pollenMap.on('moveend', updateBoundsAndZoom);
        pollenMap.on('zoomend', updateBoundsAndZoom);
        //  Сеть загружается дольше. Чтобы зоны оказались выше, их необходимо подгружать по окончанию нанесения сети.
        //  Подгрузка сети.
        $.ajax({
            url: '/ajax/network',
            dataType: 'json',
            success: (MultiPolyline) => {
                L.polyline(MultiPolyline['latlngs'], {
                    color: MultiPolyline['color'],
                    opacity: .3,
                    weight: 1
                }).bindPopup(MultiPolyline['popup']).addTo(techLayer);
                // Подгрузка зон
                $.ajax({
                    url: '/ajax/zones',
                    dataType: 'json',
                    success: (jsonData) => {
                        $.each(jsonData, (MPIndex, Polygon) => {
                            L.polygon(Polygon['latlngs'], {
                                color: Polygon['color'],
                                fillColor: Polygon['fillColor'],
                                fillOpacity: .2,
                                opacity: 1,
                                weight: 3
                            }).bindPopup(Polygon['popup']).addTo(techLayer);
                        });
                    }
                })
            }
        });

        $.ajax({  // Запрос прогнозов
            url: '/ajax/get_forecasts',
            dataType: 'json',
            success: (jsonData) => {
                intervalPath = jsonData['intervalPath'];
                $.each(jsonData['allergens'], (index, item) => {
                    allergenSelect.append('<option value="/' + item + '">' + item + '</option>');
                    $.each(jsonData['intervalPath'], (key, value) => {
                        layers[item + key] = null;
                    });
                });
                hourDelta.attr({
                    min: jsonData['interval'][0],
                    max: jsonData['interval'][1],
                    step: jsonData['interval'][2]
                });
                geoJsonPath = jsonData['root'];

                updateMap();
            }  // --success
        });
        hourDelta.trigger('input');
    });
</script>

<%def name="style()">
    <link rel="stylesheet" href="https://unpkg.com/leaflet@1.6.0/dist/leaflet.css"
          integrity="sha512-xwE/Az9zrjBIphAcBb3F6JVqxf46+CDLwfLMHloNu6KEQCAWi6HcDUbeOfBIptF7tcCzusKFjFw2yuvEpDL9wQ=="
          crossorigin=""/>
    <style>
        #container {
            position: relative;
        }

        #map-view {
            width: 100%;
            height: 800px;
            border: 1px solid black;
        }

        #player {
            position: absolute;
            right: 5px;
            bottom: 20px;
            width: 380px;
            border: 1px solid black;
            background-color: white;
            z-index: 1000;
            padding: 1em 2em;
        }
    </style>
</%def>
<%def name="script()">
    <script src="/static/js/jquery-3.4.1.min.js"></script>
    <script src="https://unpkg.com/leaflet@1.6.0/dist/leaflet.js"
            integrity="sha512-gZwIG9x3wUXg2hdXF6+rVkLF/0Vi9U8D2Ntg4Ga5I5BZpVkVxlJWbSQtXPSiUTtC0TjtGOmxa1AJPuV0CPthew=="
            crossorigin=""></script></%def>